//    10
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <memory.h>
#include <malloc.h>
#include <process.h>
#include <errno.h>
//
//using namespace std;
//////////////////////////////////////
////////
//  .2
////////
struct Student {
public:
 char Name[20];
 int Num;
 double Oklad;
};
//    
enum TypeAddDel{ First = 1 , Last = 2 , Default = Last};
// 
////////
/////////////////////////
//  .5
//     
////////
void PrintStudent(Student * pS)
{
	printf( ":  = %-15s  = %2d   = %8.2lf \n", 
		pS->Name , pS->Num, pS->Oklad  );   

};
//////////////////////////
//  .8
void StudPrintMas(  Student * pMas , int Razm)
{
	  for  (int i = 0 ;  i <  Razm ; i++ )
     {
		 PrintStudent(pMas + i); //   
	  };
};
/////////////////////////////
//       
//  .12
/////////////////////////////
void StudFileToMas( const char * FileName ,  Student ** pMas , int * pRazm)
{
long posF;
int  pFBin = _open( FileName, _S_IREAD |_O_BINARY   ); 
if ( pFBin == -1 ) { *pRazm = NULL; return;};
  posF = _lseek( pFBin, 0, SEEK_END ); //    
 *pRazm = posF / sizeof(Student);
 //*pMas = new Student[ *pRazm];
 *pMas = (Student *) calloc(  *pRazm , sizeof(Student) );
  posF = _lseek( pFBin, 0, SEEK_SET ); //  
//   
Student SBuf;
	  for  (int i = 0 ;  i <  *pRazm ; i++ )
     {
     int nByte = _read( pFBin , &SBuf , sizeof(Student));
     if ( nByte == NULL) break;
     memcpy( *pMas + i , &SBuf , sizeof(Student));
     };
//  
	_close( pFBin );
};
//
/////////////////////////////
//      ( !)
//  .13
///////////////////////////
void StudMasToFile( const char * FileName ,  Student * pMas , int Razm)
{
	char Comand[40];
//     -  Readonly
 strcpy (Comand , "attrib -R "); 
 strcat (Comand , FileName);
 system( Comand );
int pFBin = _open( FileName ,  _O_RDWR |_O_BINARY |  _O_CREAT | _O_TRUNC); 
if (  pFBin == -1 ) return;
//  
	for (  int i = 0 ; i < Razm  ; i++ )
	{ 
		_write (pFBin , pMas + i , sizeof(Student));
	};

  _close( pFBin );
//

};
///////////////////////
//    
//  .14
///////////////////////
void StudPrintFile( const char * FileName )
{
long posF;
int  pFBin = _open( FileName, _S_IREAD |_O_BINARY   ); 
 if ( pFBin != -1 )
 {
  posF = _lseek( pFBin, 0, SEEK_END ); //    
 int Razm = posF / sizeof(Student);
 if ( Razm == 0 ) { 	 _close( pFBin );    printf( "   ! \n") ; return;};
  posF = _lseek( pFBin, 0, SEEK_SET ); //  
//   
Student SBuf;
	  for  (int i = 0 ;  i <  Razm ; i++ )
     {
     int nByte = _read( pFBin , &SBuf , sizeof(Student));
     if ( nByte == NULL) break;
	 //   
	    printf( "%d - ", i + 1);
		PrintStudent(&SBuf);
     };
//  
	_close( pFBin );
 };
};

//////////////////////////////
//     
//  .15
int StudFileCount( const char * FileName ,  int * pRazm)
{
long posF;
int  pFBin = _open( FileName, _S_IREAD |_O_BINARY   ); 
if ( pFBin == -1 ) { *pRazm = NULL; return NULL;};
  posF = _lseek( pFBin, 0, SEEK_END ); //    
 *pRazm = posF / sizeof(Student);
_close( pFBin );
return *pRazm;
};
//  .15
int StudFileCountWR( const char * FileName ,  int * pRazm)
{
FILE * pF;
pF = fopen(  FileName, "r+b"); 
*pRazm =  ((int )_filelength ( pF->_file))/sizeof(Student);
//  
fclose( pF );
return *pRazm;
};
/////////////////////////
//   
//  .16
/////////////////////////
void StudClearFile(const char * FileName)
{
	char Comand[40];
//      -  Readonly
 strcpy (Comand , "attrib -R "); 
 strcat (Comand , FileName);
 system( Comand );
int pFBin = _open( FileName ,  _O_RDWR |_O_BINARY |  _O_CREAT | _O_TRUNC); 
if (  pFBin == -1 ) return;
_close( pFBin );
};
/////////////////////////
void StudClearFileWR(const char * FileName)
{
FILE * pF;
pF = fopen(  FileName, "w+"); 
//  
fclose( pF );
};
//////////////////////////////////
//   
//  .17
//////////////////////////////////
void ClearReadonlyFile(const char * FileName)
{
	char Comand[40];
//     -  Readonly
 strcpy (Comand , "attrib -R "); 
 strcat (Comand , FileName);
 system( Comand );
};
//////////////////////////////////
//  .18
//////////////////////////////////
//       (   !!)
void SwapStudent ( Student * pA , Student * pB )
{
Student Temp;
/*    
Temp = *pA;
*pA = *pB;
*pB = Temp;
*/

      memcpy( &Temp ,  pA,  sizeof(Student) );     
      memcpy( pA ,  pB,  sizeof(Student) );     
      memcpy( pB ,  &Temp,  sizeof(Student) );     
};
//////////////////////////////////
//  .20
//////////////////////////////////
void StudSortMasNum( Student * pStMas , int StudCount )
{
   for( int k =0 ;  k< StudCount - 1  ; k++)
        for ( int i =0 ;  i< StudCount - 1  ; i++ )
			if ( (pStMas + i)->Num > (pStMas + i + 1)->Num  )  // 
				         SwapStudent( pStMas + i , pStMas + i + 1 );
};
//////////////////////////////////////////////////
//      
//  .21
/////////////////////////////
void StudSortOklad(const char * FileName )
{
//     
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
//      
  for  (int i = 0 ;  i <  Razm - 1 ; i++ )
     for  (int k = 0 ;  k <  Razm - 1 ; k++ )
//   !!!!!!!!!!!!!!!!!!!!!!!!!!!
       if ( ((Student *)(pStudMas + k))->Oklad  >   ((Student *)(pStudMas + k +1))->Oklad  ) //  
             {  SwapStudent ( pStudMas + k , pStudMas + k+1 ); };
// 
StudMasToFile( FileName ,  pStudMas , Razm );
};
//////////////////////////
//  .22
//////////////////////////
double StudSumm(  const char * FileName ,  double * Sum)
{
Student * pStudMas;
int Razm;
*Sum = 0.0;
StudFileToMas( FileName ,  &pStudMas , &Razm );
for ( int i = 0 ; i < Razm ; i++)
     *Sum+= (pStudMas + i)->Oklad;
delete [] pStudMas;
return *Sum;
};
///////////////////////////////////////
//    ( )  .21
//////////////////////////////////////
void StudSortName(const char * FileName )
{
//     
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
//
/////////////////////////////
  for  (int i = 0 ;  i <  Razm - 1 ; i++ )
     for  (int k = 0 ;  k <  Razm - 1 ; k++ )
//    
       if ( strcmp(((Student *)(pStudMas + k))->Name ,   ((Student *)(pStudMas + k +1))->Name) > 0  ) //  
             {  SwapStudent ( pStudMas + k , pStudMas + k+1 ); };
// 
StudMasToFile( FileName ,  pStudMas , Razm );
};
//////////////////////////////////////
//    ( )  .21
//////////////////////////////////////
void StudSortNum(const char * FileName )
{
//     
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
StudSortMasNum( pStudMas , Razm ); //    !!! 
StudMasToFile( FileName ,  pStudMas , Razm );
};
/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
//       
///////////////////////////
//  .23.1/2
///////////////////////////
void StudAdd(const char * FileName , Student S , TypeAddDel TAD = Default ){
//
if ( TAD == Last)
{
ClearReadonlyFile(FileName);
int  pFBin = _open( FileName, _O_RDWR |_O_BINARY |  _O_APPEND     ); 
long  posF = _lseek( pFBin, 0, SEEK_END ); //    
		_write (pFBin , &S, sizeof(Student));
//  
	_close( pFBin );
	return;};
if( TAD == First )
{
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
Student * pTemp = (Student *) new Student [ Razm + 1];
      memcpy( pTemp ,  &S,  sizeof(Student) );     
for ( int i = 1 ;  i <=Razm ; i++)
      memcpy( pTemp + i ,  pStudMas + (i - 1),  sizeof(Student) );     
// 
StudMasToFile( FileName ,  pTemp , Razm + 1 );
delete [] pTemp;
delete [] pStudMas;
return;};
return;
};
/////////////////////////////////////////////
//     
//  .23.3
///////////////////////
void StudAddNum(const char * FileName , Student S , int Numb )
{
Student * pStudMas;
int Razm;
if (  Numb < 0) return;
//  
StudFileToMas( FileName ,  &pStudMas , &Razm );
if (Numb >= Razm )
{
StudAdd(FileName,  S , Last );
delete [] pStudMas;
return;
};
//
Student * pTemp = (Student *) new Student [ Razm + 1];

for ( int i = 0 , k=0 ;  i <= Razm ; i++, k++)
{
 if ( ( i - 1) == Numb)
 {
     memcpy( pTemp + i ,  &S,  sizeof(Student) ); 
	 k--;
 }
 else
 {  
	 memcpy( pTemp + i ,  pStudMas + k,  sizeof(Student) );     
 };
};
//    
StudMasToFile( FileName ,  pTemp , Razm + 1 );
delete [] pTemp;
delete [] pStudMas;
};
/////////////////////////////////////////////
//      
//  .23.4/5
/////////////////////////////////////////////
void StudDel(const char * FileName ,  TypeAddDel TAD = Last )
{
Student * pStudMas;
int Razm;
if ( TAD == Last)
{
StudFileToMas( FileName ,  &pStudMas , &Razm );
StudMasToFile( FileName ,  pStudMas , Razm - 1 );
delete [] pStudMas;
return;
};
if ( TAD == First )
{
StudFileToMas( FileName ,  &pStudMas , &Razm );
StudMasToFile( FileName ,  pStudMas + 1 , Razm - 1 );
delete [] pStudMas;
}

};
/////////////////////////////////////////////
//     
//  .23.6
///////////////////////////////////////////
void StudDelNum(const char * FileName ,  int Numb )
{
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
if (  Numb < 0 || Numb > Razm ) return;
if ( Numb == 0) {
 StudDel( FileName ,  First );
delete [] pStudMas;
return;};
if ( Numb == Razm -1) {
 StudDel( FileName ,  Last ); 
delete [] pStudMas;
return;
};
//   
Student * pTemp = (Student *) new Student [ Razm - 1];

for (int i =0, k =0  ; i < Razm   ;  i++ , k++)
{
	if ( i  == Numb )
    k--;
	else
	 memcpy( pTemp + k ,  pStudMas + i,  sizeof(Student) );     
};
StudMasToFile( FileName ,  pTemp , Razm - 1 );
delete [] pTemp;
delete [] pStudMas;
};
//
////////////////////////////////////////////////
//       
//  .23.7
///////////////////////////////////////////
void FindStudNum( const char * FileName , Student * pS , int Numb){
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
if ( Numb < 0 || Numb >= Razm )
{
	pS->Name[0] = '\0';
	pS->Num = NULL;
	pS->Oklad = NULL;
}
else
	 memcpy( pS ,  pStudMas + Numb ,  sizeof(Student) );     
delete [] pStudMas;
};
///////////////////////////////////////////
//  .23.8
///////////////////////////////////////////
void ChangeStudNum( const char * FileName , Student  pS , int Numb){
Student * pStudMas;
int Razm;
StudFileToMas( FileName ,  &pStudMas , &Razm );
if ( Numb < 0 || Numb >= Razm )
{
	delete [] pStudMas;
    return;
}
else
	 memcpy(  pStudMas + Numb ,  &pS, sizeof(Student) );     
StudMasToFile( FileName ,  pStudMas , Razm  );
delete [] pStudMas;
};
////////////////////////////////////////////////
//          ( )
//  .23.9
///////////////////////////////////////////
int FindStudName( const char * FileName , Student * pS , const char * FindName )
{
Student * pStudMas;
int Razm;
 int i ;
StudFileToMas( FileName ,  &pStudMas , &Razm );
for (  i = 0 ; i < Razm ; i++)
    if ( strcmp ( (pStudMas + i)->Name , FindName ) == 0) break;
   if ( i == Razm )
   {
//  
   	pS->Name[0] = '\0';
	pS->Num = NULL;
	pS->Oklad = NULL;
	delete [] pStudMas;
    return  -1  ;
   }
// 
   else
	 memcpy( pS ,  pStudMas + i ,  sizeof(Student) ); 

	delete [] pStudMas;
    return  i ;
};
////////////////////////////////////////////////
//      
///////////////////////////////////////////
//  .23.10
///////////////////////////////////////////
void SwapStudFile( const char * FileName , int NumA  ,int NumB)
{
Student * pStudMas;
int Razm;
 int i ;
StudFileToMas( FileName ,  &pStudMas , &Razm );
if (  NumA < 0 || NumA >= Razm || NumB < 0 || NumB >= Razm ) 
{ }
else
{SwapStudent ( pStudMas + NumA , pStudMas + NumB );
StudMasToFile( FileName ,  pStudMas , Razm  );};
//
delete [] pStudMas;
};
////////////////////
//////////////////////////////////
//  .17/23.11
//////////////////////////////////
void StudRemoveFile(const char * FileName)
{
	char Comand[40];
//     -  Readonly
 strcpy (Comand , "attrib -R "); 
 strcat (Comand , FileName);
 system( Comand );
 strcpy (Comand , "attrib -A "); 
 strcat (Comand , FileName);
 system( Comand );
//        
 strcpy (Comand , "del  "); 
 strcat (Comand , FileName);
 system( Comand );
};
/////////////////
/////////////////////////////
//       WR
void StudFileToMasWR( const char * FileName ,  Student ** pMas , int * pRazm)
{
FILE * pF;
pF = fopen(  FileName , "rb"); //    
*pRazm = _filelength(pF ->_file) /sizeof(Student);
Student SBuf;
*pMas = (Student * ) calloc( *pRazm , sizeof(Student));
int i = 0;
while (!feof(pF) )  //        
{
     fread( &SBuf, sizeof(Student) , 1, pF); //   
  if ( !feof(pF) ) 
  { memcpy( *pMas + i , &SBuf , sizeof(Student)); i++; };
     };
//  
	fclose( pF );
};
//////////
//  7 - 4.8
//     Student
void StudPrintFileWR(  const char * FileName)
{
FILE * pF;
pF = fopen(  FileName , "r+b"); //    
Student SBuf;
int i = 0;
while (!feof(pF) )  //        
{
     fread( &SBuf, sizeof(Student) , 1, pF); //   
	 if ( !feof(pF) ) {
        i++;
		printf("%d. " , i);
		 PrintStudent(&SBuf);
	 };
     };
//  
	fclose( pF );
};
//////////////////////////
//      ( !) WR
void StudMasToFileWR( const char * FileName ,  Student * pMas , int Razm)
{
FILE * pF;
pF = fopen(  FileName, "w+b"); //    
  for ( int i = 0 ; i < Razm; i++)
            fwrite( pMas + i, sizeof(Student) , 1, pF);
fclose(pF);
}; 
//////////////////////////
//////////////////////////////////////////
void FindStudNumWR( const char * FileName , Student * pS , int Numb){
FILE * pF;
pF = fopen(  FileName , "r+b"); //    
int Razm = _filelength(pF ->_file) /sizeof(Student);
if ( (Numb > 0 ) && ( Numb <= Razm ) )
{ 
long Pos1 = fseek( pF, (Numb - 1)*sizeof(Student), SEEK_SET); //        
 fread( pS, sizeof(Student) , 1, pF); //    (2-)
 // PrintStudent(pS); 
}
else
{ 
	printf( "  - %d !\n" , Numb ); //  
};

//  
	fclose( pF );
};