//   
#include "LR10_OP.h"
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <time.h>
#include <stdio.h>
#include <conio.h>
#include <string>
#include <string.h>
#include <memory.h>
#include <process.h>
//
#include <errno.h>


//using namespace std;
///
///////////////////////////////////////
//      ( )
//////////////////////////////////////
//     
//  .5
void PrintStudent(Student * pS);
//  .8
void StudPrintMas(  Student * pMas , int Razm);
//  .12
void StudFileToMas( const char * FileName ,  Student * pMas , int * pRazm); 
void StudFileToMasWR( const char * FileName ,  Student ** pMas , int * pRazm);
//  .13
void StudMasToFile( const char * FileName ,  Student * pMas , int Razm);
void StudMasToFileWR( const char * FileName ,  Student * pMas , int Razm);
//  .14
void StudPrintFile( const char * FileName );
void StudPrintFileWR(  const char * FileName);
//  .15
int StudFileCount( const char * FileName ,  int * pRazm);
int StudFileCountWR( const char * FileName ,  int * pRazm);
//  .16
void StudClearFile(const char * FileName);
void StudClearFileWR(const char * FileName);
//  .17
void ClearReadonlyFile(const char * FileName);
//  .18
void SwapStudent ( Student * pA , Student * pB );
//  .20
void StudSortMasNum( Student * pMas , int Razm );
//  .21
void StudSortOklad(const char * FileName );
//  .22
double StudSumm(  const char * FileName ,  double * Sum);
//  .22
void FindStudNum( const char * FileName , Student * pS , int Numb);
//  .22
void FindStudNumWR( const char * FileName , Student * pS , int Numb);
///////////////////////////////////////
//      (   )
//////////////////////////////////////
//  .21
void StudSortName(const char * FileName );
//  .21
void StudSortNum(const char * FileName );
//  .23.1/2
void StudAdd(const char * FileName , Student S , TypeAddDel TAD );
//  .23.4/5
void StudDel(const char * FileName ,  TypeAddDel TAD );
//  .23.3
void StudAddNum(const char * FileName , Student S , int Numb );
//  .23.6
void StudDelNum(const char * FileName ,  int Numb );
//  .23.8
void ChangeStudNum( const char * FileName , Student  pS , int Numb);
//  .23.9
int FindStudName( const char * FileName , Student * pS , const char * FindName );
//  .23.10
void SwapStudFile( const char * FileName , int NumA  ,int NumB);
//  .17/2311
void StudRemoveFile(const char * FileName);

/////////////////////////////////
void main(void)
{
system(" chcp 1251 > nul");
////////////////////////////////////  
   int pFBin = 0;
/////////////////////////////////////////////////////
//////////////
//StudRemoveFile("BDStud.bin"); //  
////////
//  .3 ( )
////////
   Student Stud1 ={ "" , 1 , 1000.0};
////////
//  .4 ( )
////////
   Student Stud2;
   Stud2.Num = 2;
   Stud2.Oklad = 2000.00;
   strcpy(Stud2.Name , "");
   printf ("  4:\n");

   	printf( "Stud2:  = %-15s  = %2d   = %8.2lf \n\n", 
		 Stud2.Name , Stud2.Num, Stud2.Oklad  );   
////////
//  .5 ( )
////////
   printf ("  5:\n");
        PrintStudent(&Stud1) ;
        PrintStudent(&Stud2) ;
////////
//  .6 ( )
////////
 //  Student * pStud = new Student;
   Student * pStud = (Student *) malloc (sizeof(Student));
   pStud->Num = 3;
   pStud->Oklad = 3000.00;
   strcpy(pStud->Name , "");
   printf ("  6:\n");
        PrintStudent( pStud ) ;
 // delete pStud;
		free( pStud );

 pStud= NULL;
////////
//  .7 ( )
////////
  Student SMas[] ={{"" , 1 , 1000.0}, {"" , 2 , 2000.0}, {"" , 3 , 3000.0}, 
         {"" , 4 , 4000.0}};
 int RazmS = sizeof(SMas)/ sizeof(Student); //   
 printf ("  7:\n");
 for (int i = 0  ; i < RazmS  ; i++ )
               PrintStudent( &SMas[i] ) ;
////////
//  .8 ( )
////////
printf ("  8:\n");
StudPrintMas(  SMas , RazmS);
////////
//  .9 ( )
////////
printf ("  9:\n");
const int Rzm = 6;
Student * pPotok = new Student[Rzm];
// 
srand( (unsigned)time( NULL ) ); //    
rand(); //       
for (int i=0  ; i < Rzm ; i++ )
  {
	  char Buf[20];
 	  char Num[10];

	  strcpy(Buf , "Stud  - ");
	  pPotok[i].Num = (rand()*9)/ RAND_MAX  ;  //  0 - 9
	  pPotok[i].Oklad = 1000.0 * 10.0 * rand() / RAND_MAX ;//  0 - 10000.0
      int n = (rand()*30)/ RAND_MAX  ;//  0 - 30
 	  strcat(Buf , itoa (n + 1 ,Num, 10 ));
	  strcpy( pPotok[i].Name , Buf);
 //     PrintStudent( &pPotok[i] );
};
StudPrintMas( pPotok , 6);
////////
//  .10 BDStud.bin
////////
///////
//  .11 ( )
////////
/////   ( _open,  _close , _write, _read   _eof)
Student ZMas[] ={{" 1" , 0 , 1000.0}, {" 2" , 0 , 2000.0}, {" 3" , 0 , 3000.0}, 
         {" 4" , 0 , 4000.0}};
 int RazmZ = sizeof(ZMas)/ sizeof(Student); //   
printf ("  11():\n");
system ( "attrib -R BDStud.bin ");  //    ,    
pFBin = _open( "BDStud.bin",  _O_RDWR |_O_BINARY |  _O_CREAT | _O_TRUNC); 
system("attrib -R BDStud.bin ");
   if (  pFBin != -1 )
{ 
	for (  int i = 0 ; i < RazmZ  ; i++ )
	{ 
    ZMas[i].Num  = i + 1;
	_write (pFBin , &ZMas[i] , sizeof(Student));
	};
     _close( pFBin );
};
   StudPrintMas( ZMas , RazmZ);

   system("attrib -R BDStud.bin ");
////////
//  .11   
/////   ( _open,  _close , _write, _read   _eof)
Student  MASStud[100]; 
Student  SRBuf;
printf ("  11( ):\n");

pFBin = _open( "BDStud.bin",  _O_RDWR |_O_BINARY ); 
if (  pFBin != -1 )
{ 
	for (  int i = 0 ; _eof(pFBin) == NULL   ; i++ )
	{ 
 
	  int nByte = _read( pFBin , &MASStud[i] , sizeof(Student));
	  PrintStudent(  &MASStud[i] );
	  RazmZ = i;  //     
	}
_close( pFBin );
};
printf ("  11(  ):\n");
StudPrintMas( MASStud ,  RazmZ + 1 );
/////////////////
//  
/////   ( fopen,  fclose , fwrite, fread   feof)
Student ZNMas[] ={{" 1N" , 10 , 1000.0}, {" 2N" , 20 , 2000.0}, {" 3N" , 30 , 3000.0}, 
         {" 4N" , 40 , 4000.0}};
RazmZ = sizeof(ZNMas)/ sizeof(Student); //   
printf ("  11(WR  ):\n");
StudPrintMas( ZNMas , RazmZ);
FILE * pFN;
pFN = fopen(  "BDStudN.bin", "w+b"); //    
  for ( int i = 0 ; i < RazmZ; i++)
            fwrite( &ZNMas[i], sizeof(Student) , 1, pFN);
fclose(pFN);
///////////////
//  
/////   ( fopen,  fclose , fwrite, fread   feof)
Student  MASStudWR[100]; 
pFN = fopen(  "BDStudN.bin" , "r+b"); //    
Student SBuf;
int i = 0;
printf ("  11(WR     ):\n");
while (!feof(pFN) )  //        
{
     fread( &SBuf, sizeof(Student) , 1, pFN); //   
  if ( !feof(pFN) ) 
  {	 memcpy( &MASStudWR[i] , &SBuf , sizeof(Student));
     PrintStudent(&SBuf); 
	  };  
  RazmZ = i;
  i++;
     };
//  
	fclose( pFN );
printf ("  11(WR    - ):\n");
StudPrintMas( MASStudWR , RazmZ);

///////////////
////////
//  .11  (   )
////////
/////   ( _open,  _close , _write, _read   _eof)
printf ("  11:  _write, _read \n");
system ( "attrib -R BDStud.bin ");  //    ,    
// 
srand( (unsigned)time( NULL ) ); //    
rand(); //       
  pFBin = _open( "BDStud.bin",  _O_RDWR |_O_BINARY |  _O_CREAT | _O_TRUNC); 
   system("attrib -R BDStud.bin ");

   if (  pFBin != -1 )
{ 
	for (  int i = 0 ; i < 4  ; i++ )
	{ 
		Student StudFile;
	    char Buf[20];
 	    char Num[10];
	  strcpy(Buf , "  - ");
    StudFile.Num = (rand()*9)/ RAND_MAX  ; 
    StudFile.Oklad = 1000.0 * 10.0 * rand() / RAND_MAX ;
 	  strcat(Buf , itoa (i + 1 ,Num, 10 ));
	  strcpy( StudFile.Name , Buf);
//
	_write (pFBin , &StudFile , sizeof(Student));
      PrintStudent( &StudFile );
	};
//
     _close( pFBin );
   system("attrib -R BDStud.bin ");
   };
/////   ( fopen,  fclose , fwrite, fread   feof)
printf ("  11 WR:  fwrite, fread \n");
// 
rand(); //       
pFN = fopen(  "BDStudN.bin", "w+b"); //    
	for (  int i = 0 ; i < 5  ; i++ )
	{ 
		Student StudFile;
	    char Buf[20];
 	    char Num[10];
	  strcpy(Buf , "  - ");
    StudFile.Num = (rand()*9)/ RAND_MAX  ; 
    StudFile.Oklad = 1000.0 * 10.0 * rand() / RAND_MAX ;
 	  strcat(Buf , itoa (i + 1 ,Num, 10 ));
	  strcpy( StudFile.Name , Buf);
      fwrite( &StudFile, sizeof(Student) , 1, pFN);
      PrintStudent( &StudFile );
	};
fclose(pFN);
// 
printf ("  11:WR -  \n");

StudPrintFileWR(   "BDStudN.bin" );
//

//  :
// -     (   ,     )
/////////////////////////////////////////////////////
////////
//  .12 ( )
////////
Student * pStMas; //
Student * pStudMas; //
int StudCount;
//
//   
/////   ( fopen,  fclose , fwrite, fread   feof)
printf ("  12:WR ()\n");
StudFileToMasWR( "BDStudN.bin" , &pStudMas , &RazmS);
StudPrintMas(  pStudMas , RazmS);
printf ("  12:\n");
//printf ("  :\n");
/////   ( _open,  _close , _write, _read   _eof)
StudFileToMas( "BDStud.bin" ,  &pStMas , &StudCount );
StudPrintMas(  pStMas , StudCount);

strcpy( (char *)((pStMas + 1)->Name) , "");
/////////////////////////////////////////////////////
// -     (   ,     )
////////
//  .13
////////
Student NZMas[] ={{" 1" , 1 , 1000.0}, {" 2" , 2 , 5000.0}, {" 3" , 3 , 3000.0}, 
         {" 4" , 4 , 4000.0}};
RazmZ = sizeof(NZMas)/ sizeof(Student); //   
//   ( = 1) 
NZMas[1].Num =5;
strcpy( NZMas[1].Name , " 2-");
printf ("  13:WR\n");
printf ("       WR\n");
StudMasToFileWR( "BDStudN.bin" ,  NZMas, RazmZ); //    !!!!!
StudPrintFileWR(  "BDStudN.bin");//  !!!!!
printf ("  13:\n");
StudMasToFile( "BDStud.bin" ,  NZMas , RazmZ );
printf ("      \n");
StudPrintFile( "BDStud.bin" );

////////
//  .14
////////
//   
printf ("  14:WR\n");
StudPrintFileWR( "BDStudN.bin" );
printf ("  14:\n");
StudPrintFile( "BDStud.bin" );
//    
////////
//  .15 ()
////////
printf ("  15:\n");
/////////////////////////////////////////////////////
printf( "    = %d \n", StudFileCountWR( "BDStudN.bin" ,  &StudCount ));
printf( "    = %d \n", StudFileCount( "BDStud.bin" ,  &StudCount ));
//      
////////
//  .13 (     )
////////
printf ("  13:\n");
Student StudMas[] ={{"" , 3 , 7000.0}, {"" , 2 , 2000.0}, {"" , 1 , 3000.0}, {"" , 4 , 4000.0}};
StudMasToFile( "BDStud.bin" ,  StudMas , StudCount );

//
////////
//  .16 ()
////////
printf ("  16:\n");
//    
StudPrintFileWR( "BDStudN.bin" );
StudClearFileWR("BDStudN.bin");
StudPrintFileWR( "BDStudN.bin" );
//   
StudPrintFile( "BDStud.bin" );//
StudClearFile("BDStud.bin");
StudPrintFile( "BDStud.bin" );

////////
//  .17 ()
////////
//
printf ("  17:\n");
//StudRemoveFile("BDStudD.bin"); //   
ClearReadonlyFile("BDStud.bin");
ClearReadonlyFile("BDStudN.bin");
StudClearFile("BDStud.bin");
StudPrintFile( "BDStud.bin" );
//
printf ("  17      (WR):\n");
StudMasToFileWR( "BDStudN.bin" ,  NZMas, sizeof(StudMas)/sizeof(Student) );
StudPrintFileWR( "BDStudN.bin" );
printf ("  17     :\n");
StudMasToFile( "BDStud.bin" ,   StudMas , sizeof(StudMas)/sizeof(Student) );
StudPrintFile( "BDStud.bin" );

////////
//  .18 ()
////////
      printf ("  18 (Sawp - ):\n");
Student StudA ={ "" , 1 , 1000.0};
Student StudB ={ "" , 2 , 2000.0};
        PrintStudent(&StudA) ;
        PrintStudent(&StudB) ;
printf ("  18 (Sawp - ):\n");
SwapStudent( &StudA , &StudB); //    
        PrintStudent(&StudA) ;
        PrintStudent(&StudB) ;
//   
printf ("  18 (Sawp - pStMas - ):\n");
StudPrintMas(  pStMas , StudCount);
printf ("  18 (Sawp - pStMas - ):\n");
SwapStudent( &pStMas[0] , &pStMas[2]); //    
StudPrintMas(  pStMas , StudCount);
//      
////////
//  .19 ()
////////
printf ("  19 (SORT - pStMas - ):\n");
StudPrintMas(  pStMas , StudCount);
//   
   for( int k =0 ;  k< StudCount - 1  ; k++)
        for ( int i =0 ;  i< StudCount - 1  ; i++ )
			if ( (pStMas + i)->Oklad > (pStMas + i + 1)->Oklad  )  // 
				         SwapStudent( pStMas + i , pStMas + i + 1 );
printf ("  19 (SORT - pStMas -  Oklad):\n");
StudPrintMas(  pStMas , StudCount);
//    
   for( int k =0 ;  k< StudCount - 1  ; k++)
        for ( int i =0 ;  i< StudCount - 1  ; i++ )
			   if ( strcmp((pStMas + i)->Name , (pStMas + i + 1)->Name ) >  0 )  // 
				         SwapStudent( pStMas + i , pStMas + i + 1 );
printf ("  19 (SORT - pStMas -  Name):\n");
StudPrintMas(  pStMas , StudCount);
//    
   for( int k =0 ;  k< StudCount - 1  ; k++)
        for ( int i =0 ;  i< StudCount - 1  ; i++ )
			   if ( (pStMas + i)->Num > (pStMas + i + 1)->Num )  // 
				         SwapStudent( pStMas + i , pStMas + i + 1 );
printf ("  19 (SORT - pStMas -  Num):\n");
StudPrintMas(  pStMas , StudCount);
////////
//  .20 ()
////////
printf ("  20 (SORT -  - ):\n");
StudPrintMas(  pStMas , StudCount);
StudSortMasNum( pStMas , StudCount );
printf ("  20 (SORT -  - ):\n");
StudPrintMas(  pStMas , StudCount);
//
////////
//  .21 ()
////////
//   (!!!)    
/////////////////////////////////////////////////////
printf ("  21 (SORT - c  ):\n");
/////////////////////////////////////////////////////
printf (":    Oklad( ):\n");
StudSortOklad("BDStud.bin" );
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
printf (":    Name:\n");
StudSortName("BDStud.bin" );
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
printf (":    Num ():\n");
StudSortNum("BDStud.bin");
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
////////
//  .22    2/3- (0 - 4 ) ()
////////
//
printf ("  22:WR -  - 2-\n");
StudPrintFile( "BDStudN.bin" );
int nFind = 2 ; //     
int Pos1;
pFN = fopen(  "BDStudN.bin" , "rb"); //    
//     
if (filelength(pFN->_file)/sizeof(Student) >= nFind ) //    
{
	Pos1 = fseek( pFN, (nFind - 1)*sizeof(Student), SEEK_SET); //        
    fread( &SBuf, sizeof(Student) , 1, pFN); //   
	PrintStudent(&SBuf); 
}
else
   printf( "  - %d !\n" , nFind ); //  
//  
	fclose( pFN );
//
printf ("  22:\n");
//  3-
nFind = 3;
StudPrintFile( "BDStud.bin" );
Student SFind ;
pFBin = _open( "BDStud.bin" , _S_IREAD |_O_BINARY   ); 
if ( pFBin != -1 ) 
{ 
long posF = _lseek( pFBin, sizeof(Student) * (nFind - 1), SEEK_SET ); //    
int nByte = _read( pFBin , &SFind , sizeof(Student));
};
printf ("   ( = 3):\n");
PrintStudent( &SFind );
//  
	_close( pFBin );
////////
////////
//  .22.1      ()
////////
///// -     
printf ("   ( = 2):\n");
FindStudNumWR( "BDStudN.bin" , &SFind , 2);
PrintStudent( &SFind );
FindStudNumWR( "BDStudN.bin" , &SFind , 20); //   
printf ("   ( = 1):\n");
FindStudNum( "BDStud.bin" , &SFind , 1);
PrintStudent( &SFind );
////////
//  .22      ()
////////
/////   ( fopen,  fclose , fwrite, fread   feof)
FILE * pFS;
double SumOk = 0;
Student SFromFile;
pFS = fopen(  "BDStudN.bin"  , "r+b"); //    
if ( pFS != NULL )
{
  while (!feof(pFS) )  //        
{
     fread( &SFromFile, sizeof(Student) , 1, pFS); //   
	 if ( !feof(pFS) ) {
		 SumOk = SumOk + SFromFile.Oklad;
	 };
 };
};
  printf ( "       WR %8.2lf \n" , SumOk );

//  
	fclose( pFS );
////////////

double SumStip = 0;
Student SIntg;
printf ("  22 ( ):\n");
pFBin = _open( "BDStud.bin" , _S_IREAD |_O_BINARY   ); 
if (  pFBin != -1 )
{ 
	for (  int i = 0 ; _eof(pFBin) == NULL   ; i++ )
	{ 
   int nByte = _read( pFBin , &SIntg , sizeof(Student));
	  SumStip = SumStip + SIntg.Oklad;
	}
_close( pFBin );
};
printf ( "     =    %8.2lf \n" , SumStip );

////////
//  .22 ()
//////// 
double SumOklad;
printf ( "    =  %8.2lf \n" , StudSumm( "BDStud.bin" , &SumOklad));
///////////////////////////////////////////////////////
/////////////////////////////////////////////////////
//      
ClearReadonlyFile("BDStud.bin");
// StudClearFile("BDStud.bin");
// StudRemoveFile("BDStud.bin");
/////   
///////////////////////////////////////
//  .23 ()
///////////////////////////////////////
////////
//  .23.1 ()
////////
//   (  )
printf (" ():\n");
Student SFirst = {"" , 22 , 3400.00};
StudAdd("BDStud.bin",  SFirst , First );
StudPrintFile( "BDStud.bin" );
////////
//  .23.2 ()
////////
// -   ( )
printf (" ():\n");
Student SLast = {"" , 22 , 3400.00};
StudAdd("BDStud.bin",  SLast );
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
////////
//  .23.3 ()
////////
//    ()
/////////////////////////////////////////////////////
printf (" ():\n");
Student SNumb = {"   - 2" , 33 , 5500.00};
StudAddNum("BDStud.bin",  SNumb, 3);
StudPrintFile( "BDStud.bin" );
///// -     (?  )
/////////////////////////////////////////////////////
////////
//  .23.4 ()
////////printf (" ():\n");
StudDel("BDStud.bin",  First );
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
////////
//  .23.5 ()
////////
printf (" ():\n");
StudDel("BDStud.bin",  Last );
//StudDel("BDStud.bin" );
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
////////
//  .23.6 ()
////////
printf (" ():\n");
StudDelNum("BDStud.bin",  4 );
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
////////
//  .23.7 ()
////////
///// -     
printf (" ():\n");
Student * pFind = new Student;
FindStudNum( "BDStud.bin" , pFind , 2);
PrintStudent( pFind );
/////////////////////////////////////////////////////
// -    
////////
//  .23.8 ()
////////
printf ("  ():\n");
Student SChang ={"" , 11, 111.00};
ChangeStudNum( "BDStud.bin" , SChang , 2);
StudPrintFile( "BDStud.bin" );
/////////////////////////////////////////////////////
// -       ( -    )    
////////
//  .23.9 ()
////////
int n;
printf ("  :\n");
if ( ( n =FindStudName( "BDStud.bin" , pFind , "" )) != -1)
{ printf ("   = %d  \n", n );
printf (" : ");
PrintStudent( pFind );
}
else 
printf ("  ! ");
/////////////////////////////////////////////////////
////////
//  .23.10 ()
////////
// Swap     
printf (" SWAP    : 1<->3\n");
SwapStudFile( "BDStud.bin" , 1  ,3 );
StudPrintFile( "BDStud.bin" );
///////////////////////////////////////////////////////
 delete [] pStMas;
/////////////////////////////////////////////////////
   system("PAUSE");
/////////////////////////////////////////////////////

}